// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: PutThroughInfo.proto

package com.fss.fo.mserver.exchange;

public final class PutThroughInfoProtos {
  private PutThroughInfoProtos() {}
  public static void registerAllExtensions(
      com.google.protobuf.ExtensionRegistry registry) {
  }
  public interface PutThroughInfoOrBuilder
      extends com.google.protobuf.MessageOrBuilder {

    // optional string Id = 1;
    /**
     * <code>optional string Id = 1;</code>
     */
    boolean hasId();
    /**
     * <code>optional string Id = 1;</code>
     */
    java.lang.String getId();
    /**
     * <code>optional string Id = 1;</code>
     */
    com.google.protobuf.ByteString
        getIdBytes();

    // optional string Symbol = 2;
    /**
     * <code>optional string Symbol = 2;</code>
     */
    boolean hasSymbol();
    /**
     * <code>optional string Symbol = 2;</code>
     */
    java.lang.String getSymbol();
    /**
     * <code>optional string Symbol = 2;</code>
     */
    com.google.protobuf.ByteString
        getSymbolBytes();

    // optional int64 Vol = 3;
    /**
     * <code>optional int64 Vol = 3;</code>
     */
    boolean hasVol();
    /**
     * <code>optional int64 Vol = 3;</code>
     */
    long getVol();

    // optional int64 MatchVol = 4;
    /**
     * <code>optional int64 MatchVol = 4;</code>
     */
    boolean hasMatchVol();
    /**
     * <code>optional int64 MatchVol = 4;</code>
     */
    long getMatchVol();

    // optional int32 Price = 5;
    /**
     * <code>optional int32 Price = 5;</code>
     */
    boolean hasPrice();
    /**
     * <code>optional int32 Price = 5;</code>
     */
    int getPrice();

    // optional string Side = 6;
    /**
     * <code>optional string Side = 6;</code>
     */
    boolean hasSide();
    /**
     * <code>optional string Side = 6;</code>
     */
    java.lang.String getSide();
    /**
     * <code>optional string Side = 6;</code>
     */
    com.google.protobuf.ByteString
        getSideBytes();

    // optional string Time = 7;
    /**
     * <code>optional string Time = 7;</code>
     */
    boolean hasTime();
    /**
     * <code>optional string Time = 7;</code>
     */
    java.lang.String getTime();
    /**
     * <code>optional string Time = 7;</code>
     */
    com.google.protobuf.ByteString
        getTimeBytes();

    // optional bool IsActive = 8;
    /**
     * <code>optional bool IsActive = 8;</code>
     */
    boolean hasIsActive();
    /**
     * <code>optional bool IsActive = 8;</code>
     */
    boolean getIsActive();

    // optional string MarketId = 9;
    /**
     * <code>optional string MarketId = 9;</code>
     */
    boolean hasMarketId();
    /**
     * <code>optional string MarketId = 9;</code>
     */
    java.lang.String getMarketId();
    /**
     * <code>optional string MarketId = 9;</code>
     */
    com.google.protobuf.ByteString
        getMarketIdBytes();

    // optional string OrderId = 10;
    /**
     * <code>optional string OrderId = 10;</code>
     */
    boolean hasOrderId();
    /**
     * <code>optional string OrderId = 10;</code>
     */
    java.lang.String getOrderId();
    /**
     * <code>optional string OrderId = 10;</code>
     */
    com.google.protobuf.ByteString
        getOrderIdBytes();

    // optional string tradingdate = 11;
    /**
     * <code>optional string tradingdate = 11;</code>
     */
    boolean hasTradingdate();
    /**
     * <code>optional string tradingdate = 11;</code>
     */
    java.lang.String getTradingdate();
    /**
     * <code>optional string tradingdate = 11;</code>
     */
    com.google.protobuf.ByteString
        getTradingdateBytes();

    // optional int64 LastSeq = 12;
    /**
     * <code>optional int64 LastSeq = 12;</code>
     */
    boolean hasLastSeq();
    /**
     * <code>optional int64 LastSeq = 12;</code>
     */
    long getLastSeq();

    // optional string PColor = 13;
    /**
     * <code>optional string PColor = 13;</code>
     */
    boolean hasPColor();
    /**
     * <code>optional string PColor = 13;</code>
     */
    java.lang.String getPColor();
    /**
     * <code>optional string PColor = 13;</code>
     */
    com.google.protobuf.ByteString
        getPColorBytes();
  }
  /**
   * Protobuf type {@code com.fss.fo.mserver.exchange.PutThroughInfo}
   */
  public static final class PutThroughInfo extends
      com.google.protobuf.GeneratedMessage
      implements PutThroughInfoOrBuilder {
    // Use PutThroughInfo.newBuilder() to construct.
    private PutThroughInfo(com.google.protobuf.GeneratedMessage.Builder<?> builder) {
      super(builder);
      this.unknownFields = builder.getUnknownFields();
    }
    private PutThroughInfo(boolean noInit) { this.unknownFields = com.google.protobuf.UnknownFieldSet.getDefaultInstance(); }

    private static final PutThroughInfo defaultInstance;
    public static PutThroughInfo getDefaultInstance() {
      return defaultInstance;
    }

    public PutThroughInfo getDefaultInstanceForType() {
      return defaultInstance;
    }

    private final com.google.protobuf.UnknownFieldSet unknownFields;
    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
        getUnknownFields() {
      return this.unknownFields;
    }
    private PutThroughInfo(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      initFields();
      int mutable_bitField0_ = 0;
      com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
            case 10: {
              bitField0_ |= 0x00000001;
              id_ = input.readBytes();
              break;
            }
            case 18: {
              bitField0_ |= 0x00000002;
              symbol_ = input.readBytes();
              break;
            }
            case 24: {
              bitField0_ |= 0x00000004;
              vol_ = input.readInt64();
              break;
            }
            case 32: {
              bitField0_ |= 0x00000008;
              matchVol_ = input.readInt64();
              break;
            }
            case 40: {
              bitField0_ |= 0x00000010;
              price_ = input.readInt32();
              break;
            }
            case 50: {
              bitField0_ |= 0x00000020;
              side_ = input.readBytes();
              break;
            }
            case 58: {
              bitField0_ |= 0x00000040;
              time_ = input.readBytes();
              break;
            }
            case 64: {
              bitField0_ |= 0x00000080;
              isActive_ = input.readBool();
              break;
            }
            case 74: {
              bitField0_ |= 0x00000100;
              marketId_ = input.readBytes();
              break;
            }
            case 82: {
              bitField0_ |= 0x00000200;
              orderId_ = input.readBytes();
              break;
            }
            case 90: {
              bitField0_ |= 0x00000400;
              tradingdate_ = input.readBytes();
              break;
            }
            case 96: {
              bitField0_ |= 0x00000800;
              lastSeq_ = input.readInt64();
              break;
            }
            case 106: {
              bitField0_ |= 0x00001000;
              pColor_ = input.readBytes();
              break;
            }
          }
        }
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(
            e.getMessage()).setUnfinishedMessage(this);
      } finally {
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.fss.fo.mserver.exchange.PutThroughInfoProtos.internal_static_com_fss_fo_mserver_exchange_PutThroughInfo_descriptor;
    }

    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.fss.fo.mserver.exchange.PutThroughInfoProtos.internal_static_com_fss_fo_mserver_exchange_PutThroughInfo_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.fss.fo.mserver.exchange.PutThroughInfoProtos.PutThroughInfo.class, com.fss.fo.mserver.exchange.PutThroughInfoProtos.PutThroughInfo.Builder.class);
    }

    public static com.google.protobuf.Parser<PutThroughInfo> PARSER =
        new com.google.protobuf.AbstractParser<PutThroughInfo>() {
      public PutThroughInfo parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return new PutThroughInfo(input, extensionRegistry);
      }
    };

    @java.lang.Override
    public com.google.protobuf.Parser<PutThroughInfo> getParserForType() {
      return PARSER;
    }

    private int bitField0_;
    // optional string Id = 1;
    public static final int ID_FIELD_NUMBER = 1;
    private java.lang.Object id_;
    /**
     * <code>optional string Id = 1;</code>
     */
    public boolean hasId() {
      return ((bitField0_ & 0x00000001) == 0x00000001);
    }
    /**
     * <code>optional string Id = 1;</code>
     */
    public java.lang.String getId() {
      java.lang.Object ref = id_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          id_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string Id = 1;</code>
     */
    public com.google.protobuf.ByteString
        getIdBytes() {
      java.lang.Object ref = id_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        id_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional string Symbol = 2;
    public static final int SYMBOL_FIELD_NUMBER = 2;
    private java.lang.Object symbol_;
    /**
     * <code>optional string Symbol = 2;</code>
     */
    public boolean hasSymbol() {
      return ((bitField0_ & 0x00000002) == 0x00000002);
    }
    /**
     * <code>optional string Symbol = 2;</code>
     */
    public java.lang.String getSymbol() {
      java.lang.Object ref = symbol_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          symbol_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string Symbol = 2;</code>
     */
    public com.google.protobuf.ByteString
        getSymbolBytes() {
      java.lang.Object ref = symbol_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        symbol_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional int64 Vol = 3;
    public static final int VOL_FIELD_NUMBER = 3;
    private long vol_;
    /**
     * <code>optional int64 Vol = 3;</code>
     */
    public boolean hasVol() {
      return ((bitField0_ & 0x00000004) == 0x00000004);
    }
    /**
     * <code>optional int64 Vol = 3;</code>
     */
    public long getVol() {
      return vol_;
    }

    // optional int64 MatchVol = 4;
    public static final int MATCHVOL_FIELD_NUMBER = 4;
    private long matchVol_;
    /**
     * <code>optional int64 MatchVol = 4;</code>
     */
    public boolean hasMatchVol() {
      return ((bitField0_ & 0x00000008) == 0x00000008);
    }
    /**
     * <code>optional int64 MatchVol = 4;</code>
     */
    public long getMatchVol() {
      return matchVol_;
    }

    // optional int32 Price = 5;
    public static final int PRICE_FIELD_NUMBER = 5;
    private int price_;
    /**
     * <code>optional int32 Price = 5;</code>
     */
    public boolean hasPrice() {
      return ((bitField0_ & 0x00000010) == 0x00000010);
    }
    /**
     * <code>optional int32 Price = 5;</code>
     */
    public int getPrice() {
      return price_;
    }

    // optional string Side = 6;
    public static final int SIDE_FIELD_NUMBER = 6;
    private java.lang.Object side_;
    /**
     * <code>optional string Side = 6;</code>
     */
    public boolean hasSide() {
      return ((bitField0_ & 0x00000020) == 0x00000020);
    }
    /**
     * <code>optional string Side = 6;</code>
     */
    public java.lang.String getSide() {
      java.lang.Object ref = side_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          side_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string Side = 6;</code>
     */
    public com.google.protobuf.ByteString
        getSideBytes() {
      java.lang.Object ref = side_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        side_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional string Time = 7;
    public static final int TIME_FIELD_NUMBER = 7;
    private java.lang.Object time_;
    /**
     * <code>optional string Time = 7;</code>
     */
    public boolean hasTime() {
      return ((bitField0_ & 0x00000040) == 0x00000040);
    }
    /**
     * <code>optional string Time = 7;</code>
     */
    public java.lang.String getTime() {
      java.lang.Object ref = time_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          time_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string Time = 7;</code>
     */
    public com.google.protobuf.ByteString
        getTimeBytes() {
      java.lang.Object ref = time_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        time_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional bool IsActive = 8;
    public static final int ISACTIVE_FIELD_NUMBER = 8;
    private boolean isActive_;
    /**
     * <code>optional bool IsActive = 8;</code>
     */
    public boolean hasIsActive() {
      return ((bitField0_ & 0x00000080) == 0x00000080);
    }
    /**
     * <code>optional bool IsActive = 8;</code>
     */
    public boolean getIsActive() {
      return isActive_;
    }

    // optional string MarketId = 9;
    public static final int MARKETID_FIELD_NUMBER = 9;
    private java.lang.Object marketId_;
    /**
     * <code>optional string MarketId = 9;</code>
     */
    public boolean hasMarketId() {
      return ((bitField0_ & 0x00000100) == 0x00000100);
    }
    /**
     * <code>optional string MarketId = 9;</code>
     */
    public java.lang.String getMarketId() {
      java.lang.Object ref = marketId_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          marketId_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string MarketId = 9;</code>
     */
    public com.google.protobuf.ByteString
        getMarketIdBytes() {
      java.lang.Object ref = marketId_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        marketId_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional string OrderId = 10;
    public static final int ORDERID_FIELD_NUMBER = 10;
    private java.lang.Object orderId_;
    /**
     * <code>optional string OrderId = 10;</code>
     */
    public boolean hasOrderId() {
      return ((bitField0_ & 0x00000200) == 0x00000200);
    }
    /**
     * <code>optional string OrderId = 10;</code>
     */
    public java.lang.String getOrderId() {
      java.lang.Object ref = orderId_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          orderId_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string OrderId = 10;</code>
     */
    public com.google.protobuf.ByteString
        getOrderIdBytes() {
      java.lang.Object ref = orderId_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        orderId_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional string tradingdate = 11;
    public static final int TRADINGDATE_FIELD_NUMBER = 11;
    private java.lang.Object tradingdate_;
    /**
     * <code>optional string tradingdate = 11;</code>
     */
    public boolean hasTradingdate() {
      return ((bitField0_ & 0x00000400) == 0x00000400);
    }
    /**
     * <code>optional string tradingdate = 11;</code>
     */
    public java.lang.String getTradingdate() {
      java.lang.Object ref = tradingdate_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          tradingdate_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string tradingdate = 11;</code>
     */
    public com.google.protobuf.ByteString
        getTradingdateBytes() {
      java.lang.Object ref = tradingdate_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        tradingdate_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    // optional int64 LastSeq = 12;
    public static final int LASTSEQ_FIELD_NUMBER = 12;
    private long lastSeq_;
    /**
     * <code>optional int64 LastSeq = 12;</code>
     */
    public boolean hasLastSeq() {
      return ((bitField0_ & 0x00000800) == 0x00000800);
    }
    /**
     * <code>optional int64 LastSeq = 12;</code>
     */
    public long getLastSeq() {
      return lastSeq_;
    }

    // optional string PColor = 13;
    public static final int PCOLOR_FIELD_NUMBER = 13;
    private java.lang.Object pColor_;
    /**
     * <code>optional string PColor = 13;</code>
     */
    public boolean hasPColor() {
      return ((bitField0_ & 0x00001000) == 0x00001000);
    }
    /**
     * <code>optional string PColor = 13;</code>
     */
    public java.lang.String getPColor() {
      java.lang.Object ref = pColor_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = 
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          pColor_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string PColor = 13;</code>
     */
    public com.google.protobuf.ByteString
        getPColorBytes() {
      java.lang.Object ref = pColor_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        pColor_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }

    private void initFields() {
      id_ = "";
      symbol_ = "";
      vol_ = 0L;
      matchVol_ = 0L;
      price_ = 0;
      side_ = "";
      time_ = "";
      isActive_ = false;
      marketId_ = "";
      orderId_ = "";
      tradingdate_ = "";
      lastSeq_ = 0L;
      pColor_ = "";
    }
    private byte memoizedIsInitialized = -1;
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized != -1) return isInitialized == 1;

      memoizedIsInitialized = 1;
      return true;
    }

    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        output.writeBytes(1, getIdBytes());
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        output.writeBytes(2, getSymbolBytes());
      }
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        output.writeInt64(3, vol_);
      }
      if (((bitField0_ & 0x00000008) == 0x00000008)) {
        output.writeInt64(4, matchVol_);
      }
      if (((bitField0_ & 0x00000010) == 0x00000010)) {
        output.writeInt32(5, price_);
      }
      if (((bitField0_ & 0x00000020) == 0x00000020)) {
        output.writeBytes(6, getSideBytes());
      }
      if (((bitField0_ & 0x00000040) == 0x00000040)) {
        output.writeBytes(7, getTimeBytes());
      }
      if (((bitField0_ & 0x00000080) == 0x00000080)) {
        output.writeBool(8, isActive_);
      }
      if (((bitField0_ & 0x00000100) == 0x00000100)) {
        output.writeBytes(9, getMarketIdBytes());
      }
      if (((bitField0_ & 0x00000200) == 0x00000200)) {
        output.writeBytes(10, getOrderIdBytes());
      }
      if (((bitField0_ & 0x00000400) == 0x00000400)) {
        output.writeBytes(11, getTradingdateBytes());
      }
      if (((bitField0_ & 0x00000800) == 0x00000800)) {
        output.writeInt64(12, lastSeq_);
      }
      if (((bitField0_ & 0x00001000) == 0x00001000)) {
        output.writeBytes(13, getPColorBytes());
      }
      getUnknownFields().writeTo(output);
    }

    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;

      size = 0;
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(1, getIdBytes());
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(2, getSymbolBytes());
      }
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(3, vol_);
      }
      if (((bitField0_ & 0x00000008) == 0x00000008)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(4, matchVol_);
      }
      if (((bitField0_ & 0x00000010) == 0x00000010)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(5, price_);
      }
      if (((bitField0_ & 0x00000020) == 0x00000020)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(6, getSideBytes());
      }
      if (((bitField0_ & 0x00000040) == 0x00000040)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(7, getTimeBytes());
      }
      if (((bitField0_ & 0x00000080) == 0x00000080)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBoolSize(8, isActive_);
      }
      if (((bitField0_ & 0x00000100) == 0x00000100)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(9, getMarketIdBytes());
      }
      if (((bitField0_ & 0x00000200) == 0x00000200)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(10, getOrderIdBytes());
      }
      if (((bitField0_ & 0x00000400) == 0x00000400)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(11, getTradingdateBytes());
      }
      if (((bitField0_ & 0x00000800) == 0x00000800)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(12, lastSeq_);
      }
      if (((bitField0_ & 0x00001000) == 0x00001000)) {
        size += com.google.protobuf.CodedOutputStream
          .computeBytesSize(13, getPColorBytes());
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }

    private static final long serialVersionUID = 0L;
    @java.lang.Override
    protected java.lang.Object writeReplace()
        throws java.io.ObjectStreamException {
      return super.writeReplace();
    }

    public static com.fss.fo.mserver.exchange.PutThroughInfoProtos.PutThroughInfo parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.fss.fo.mserver.exchange.PutThroughInfoProtos.PutThroughInfo parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.fss.fo.mserver.exchange.PutThroughInfoProtos.PutThroughInfo parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static com.fss.fo.mserver.exchange.PutThroughInfoProtos.PutThroughInfo parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static com.fss.fo.mserver.exchange.PutThroughInfoProtos.PutThroughInfo parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return PARSER.parseFrom(input);
    }
    public static com.fss.fo.mserver.exchange.PutThroughInfoProtos.PutThroughInfo parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseFrom(input, extensionRegistry);
    }
    public static com.fss.fo.mserver.exchange.PutThroughInfoProtos.PutThroughInfo parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return PARSER.parseDelimitedFrom(input);
    }
    public static com.fss.fo.mserver.exchange.PutThroughInfoProtos.PutThroughInfo parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseDelimitedFrom(input, extensionRegistry);
    }
    public static com.fss.fo.mserver.exchange.PutThroughInfoProtos.PutThroughInfo parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return PARSER.parseFrom(input);
    }
    public static com.fss.fo.mserver.exchange.PutThroughInfoProtos.PutThroughInfo parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return PARSER.parseFrom(input, extensionRegistry);
    }

    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(com.fss.fo.mserver.exchange.PutThroughInfoProtos.PutThroughInfo prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessage.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * Protobuf type {@code com.fss.fo.mserver.exchange.PutThroughInfo}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder>
       implements com.fss.fo.mserver.exchange.PutThroughInfoProtos.PutThroughInfoOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return com.fss.fo.mserver.exchange.PutThroughInfoProtos.internal_static_com_fss_fo_mserver_exchange_PutThroughInfo_descriptor;
      }

      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return com.fss.fo.mserver.exchange.PutThroughInfoProtos.internal_static_com_fss_fo_mserver_exchange_PutThroughInfo_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                com.fss.fo.mserver.exchange.PutThroughInfoProtos.PutThroughInfo.class, com.fss.fo.mserver.exchange.PutThroughInfoProtos.PutThroughInfo.Builder.class);
      }

      // Construct using com.fss.fo.mserver.exchange.PutThroughInfoProtos.PutThroughInfo.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          com.google.protobuf.GeneratedMessage.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
        }
      }
      private static Builder create() {
        return new Builder();
      }

      public Builder clear() {
        super.clear();
        id_ = "";
        bitField0_ = (bitField0_ & ~0x00000001);
        symbol_ = "";
        bitField0_ = (bitField0_ & ~0x00000002);
        vol_ = 0L;
        bitField0_ = (bitField0_ & ~0x00000004);
        matchVol_ = 0L;
        bitField0_ = (bitField0_ & ~0x00000008);
        price_ = 0;
        bitField0_ = (bitField0_ & ~0x00000010);
        side_ = "";
        bitField0_ = (bitField0_ & ~0x00000020);
        time_ = "";
        bitField0_ = (bitField0_ & ~0x00000040);
        isActive_ = false;
        bitField0_ = (bitField0_ & ~0x00000080);
        marketId_ = "";
        bitField0_ = (bitField0_ & ~0x00000100);
        orderId_ = "";
        bitField0_ = (bitField0_ & ~0x00000200);
        tradingdate_ = "";
        bitField0_ = (bitField0_ & ~0x00000400);
        lastSeq_ = 0L;
        bitField0_ = (bitField0_ & ~0x00000800);
        pColor_ = "";
        bitField0_ = (bitField0_ & ~0x00001000);
        return this;
      }

      public Builder clone() {
        return create().mergeFrom(buildPartial());
      }

      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return com.fss.fo.mserver.exchange.PutThroughInfoProtos.internal_static_com_fss_fo_mserver_exchange_PutThroughInfo_descriptor;
      }

      public com.fss.fo.mserver.exchange.PutThroughInfoProtos.PutThroughInfo getDefaultInstanceForType() {
        return com.fss.fo.mserver.exchange.PutThroughInfoProtos.PutThroughInfo.getDefaultInstance();
      }

      public com.fss.fo.mserver.exchange.PutThroughInfoProtos.PutThroughInfo build() {
        com.fss.fo.mserver.exchange.PutThroughInfoProtos.PutThroughInfo result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      public com.fss.fo.mserver.exchange.PutThroughInfoProtos.PutThroughInfo buildPartial() {
        com.fss.fo.mserver.exchange.PutThroughInfoProtos.PutThroughInfo result = new com.fss.fo.mserver.exchange.PutThroughInfoProtos.PutThroughInfo(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) == 0x00000001)) {
          to_bitField0_ |= 0x00000001;
        }
        result.id_ = id_;
        if (((from_bitField0_ & 0x00000002) == 0x00000002)) {
          to_bitField0_ |= 0x00000002;
        }
        result.symbol_ = symbol_;
        if (((from_bitField0_ & 0x00000004) == 0x00000004)) {
          to_bitField0_ |= 0x00000004;
        }
        result.vol_ = vol_;
        if (((from_bitField0_ & 0x00000008) == 0x00000008)) {
          to_bitField0_ |= 0x00000008;
        }
        result.matchVol_ = matchVol_;
        if (((from_bitField0_ & 0x00000010) == 0x00000010)) {
          to_bitField0_ |= 0x00000010;
        }
        result.price_ = price_;
        if (((from_bitField0_ & 0x00000020) == 0x00000020)) {
          to_bitField0_ |= 0x00000020;
        }
        result.side_ = side_;
        if (((from_bitField0_ & 0x00000040) == 0x00000040)) {
          to_bitField0_ |= 0x00000040;
        }
        result.time_ = time_;
        if (((from_bitField0_ & 0x00000080) == 0x00000080)) {
          to_bitField0_ |= 0x00000080;
        }
        result.isActive_ = isActive_;
        if (((from_bitField0_ & 0x00000100) == 0x00000100)) {
          to_bitField0_ |= 0x00000100;
        }
        result.marketId_ = marketId_;
        if (((from_bitField0_ & 0x00000200) == 0x00000200)) {
          to_bitField0_ |= 0x00000200;
        }
        result.orderId_ = orderId_;
        if (((from_bitField0_ & 0x00000400) == 0x00000400)) {
          to_bitField0_ |= 0x00000400;
        }
        result.tradingdate_ = tradingdate_;
        if (((from_bitField0_ & 0x00000800) == 0x00000800)) {
          to_bitField0_ |= 0x00000800;
        }
        result.lastSeq_ = lastSeq_;
        if (((from_bitField0_ & 0x00001000) == 0x00001000)) {
          to_bitField0_ |= 0x00001000;
        }
        result.pColor_ = pColor_;
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }

      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof com.fss.fo.mserver.exchange.PutThroughInfoProtos.PutThroughInfo) {
          return mergeFrom((com.fss.fo.mserver.exchange.PutThroughInfoProtos.PutThroughInfo)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(com.fss.fo.mserver.exchange.PutThroughInfoProtos.PutThroughInfo other) {
        if (other == com.fss.fo.mserver.exchange.PutThroughInfoProtos.PutThroughInfo.getDefaultInstance()) return this;
        if (other.hasId()) {
          bitField0_ |= 0x00000001;
          id_ = other.id_;
          onChanged();
        }
        if (other.hasSymbol()) {
          bitField0_ |= 0x00000002;
          symbol_ = other.symbol_;
          onChanged();
        }
        if (other.hasVol()) {
          setVol(other.getVol());
        }
        if (other.hasMatchVol()) {
          setMatchVol(other.getMatchVol());
        }
        if (other.hasPrice()) {
          setPrice(other.getPrice());
        }
        if (other.hasSide()) {
          bitField0_ |= 0x00000020;
          side_ = other.side_;
          onChanged();
        }
        if (other.hasTime()) {
          bitField0_ |= 0x00000040;
          time_ = other.time_;
          onChanged();
        }
        if (other.hasIsActive()) {
          setIsActive(other.getIsActive());
        }
        if (other.hasMarketId()) {
          bitField0_ |= 0x00000100;
          marketId_ = other.marketId_;
          onChanged();
        }
        if (other.hasOrderId()) {
          bitField0_ |= 0x00000200;
          orderId_ = other.orderId_;
          onChanged();
        }
        if (other.hasTradingdate()) {
          bitField0_ |= 0x00000400;
          tradingdate_ = other.tradingdate_;
          onChanged();
        }
        if (other.hasLastSeq()) {
          setLastSeq(other.getLastSeq());
        }
        if (other.hasPColor()) {
          bitField0_ |= 0x00001000;
          pColor_ = other.pColor_;
          onChanged();
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }

      public final boolean isInitialized() {
        return true;
      }

      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        com.fss.fo.mserver.exchange.PutThroughInfoProtos.PutThroughInfo parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          parsedMessage = (com.fss.fo.mserver.exchange.PutThroughInfoProtos.PutThroughInfo) e.getUnfinishedMessage();
          throw e;
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      // optional string Id = 1;
      private java.lang.Object id_ = "";
      /**
       * <code>optional string Id = 1;</code>
       */
      public boolean hasId() {
        return ((bitField0_ & 0x00000001) == 0x00000001);
      }
      /**
       * <code>optional string Id = 1;</code>
       */
      public java.lang.String getId() {
        java.lang.Object ref = id_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          id_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string Id = 1;</code>
       */
      public com.google.protobuf.ByteString
          getIdBytes() {
        java.lang.Object ref = id_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          id_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string Id = 1;</code>
       */
      public Builder setId(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000001;
        id_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string Id = 1;</code>
       */
      public Builder clearId() {
        bitField0_ = (bitField0_ & ~0x00000001);
        id_ = getDefaultInstance().getId();
        onChanged();
        return this;
      }
      /**
       * <code>optional string Id = 1;</code>
       */
      public Builder setIdBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000001;
        id_ = value;
        onChanged();
        return this;
      }

      // optional string Symbol = 2;
      private java.lang.Object symbol_ = "";
      /**
       * <code>optional string Symbol = 2;</code>
       */
      public boolean hasSymbol() {
        return ((bitField0_ & 0x00000002) == 0x00000002);
      }
      /**
       * <code>optional string Symbol = 2;</code>
       */
      public java.lang.String getSymbol() {
        java.lang.Object ref = symbol_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          symbol_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string Symbol = 2;</code>
       */
      public com.google.protobuf.ByteString
          getSymbolBytes() {
        java.lang.Object ref = symbol_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          symbol_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string Symbol = 2;</code>
       */
      public Builder setSymbol(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000002;
        symbol_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string Symbol = 2;</code>
       */
      public Builder clearSymbol() {
        bitField0_ = (bitField0_ & ~0x00000002);
        symbol_ = getDefaultInstance().getSymbol();
        onChanged();
        return this;
      }
      /**
       * <code>optional string Symbol = 2;</code>
       */
      public Builder setSymbolBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000002;
        symbol_ = value;
        onChanged();
        return this;
      }

      // optional int64 Vol = 3;
      private long vol_ ;
      /**
       * <code>optional int64 Vol = 3;</code>
       */
      public boolean hasVol() {
        return ((bitField0_ & 0x00000004) == 0x00000004);
      }
      /**
       * <code>optional int64 Vol = 3;</code>
       */
      public long getVol() {
        return vol_;
      }
      /**
       * <code>optional int64 Vol = 3;</code>
       */
      public Builder setVol(long value) {
        bitField0_ |= 0x00000004;
        vol_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional int64 Vol = 3;</code>
       */
      public Builder clearVol() {
        bitField0_ = (bitField0_ & ~0x00000004);
        vol_ = 0L;
        onChanged();
        return this;
      }

      // optional int64 MatchVol = 4;
      private long matchVol_ ;
      /**
       * <code>optional int64 MatchVol = 4;</code>
       */
      public boolean hasMatchVol() {
        return ((bitField0_ & 0x00000008) == 0x00000008);
      }
      /**
       * <code>optional int64 MatchVol = 4;</code>
       */
      public long getMatchVol() {
        return matchVol_;
      }
      /**
       * <code>optional int64 MatchVol = 4;</code>
       */
      public Builder setMatchVol(long value) {
        bitField0_ |= 0x00000008;
        matchVol_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional int64 MatchVol = 4;</code>
       */
      public Builder clearMatchVol() {
        bitField0_ = (bitField0_ & ~0x00000008);
        matchVol_ = 0L;
        onChanged();
        return this;
      }

      // optional int32 Price = 5;
      private int price_ ;
      /**
       * <code>optional int32 Price = 5;</code>
       */
      public boolean hasPrice() {
        return ((bitField0_ & 0x00000010) == 0x00000010);
      }
      /**
       * <code>optional int32 Price = 5;</code>
       */
      public int getPrice() {
        return price_;
      }
      /**
       * <code>optional int32 Price = 5;</code>
       */
      public Builder setPrice(int value) {
        bitField0_ |= 0x00000010;
        price_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional int32 Price = 5;</code>
       */
      public Builder clearPrice() {
        bitField0_ = (bitField0_ & ~0x00000010);
        price_ = 0;
        onChanged();
        return this;
      }

      // optional string Side = 6;
      private java.lang.Object side_ = "";
      /**
       * <code>optional string Side = 6;</code>
       */
      public boolean hasSide() {
        return ((bitField0_ & 0x00000020) == 0x00000020);
      }
      /**
       * <code>optional string Side = 6;</code>
       */
      public java.lang.String getSide() {
        java.lang.Object ref = side_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          side_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string Side = 6;</code>
       */
      public com.google.protobuf.ByteString
          getSideBytes() {
        java.lang.Object ref = side_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          side_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string Side = 6;</code>
       */
      public Builder setSide(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000020;
        side_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string Side = 6;</code>
       */
      public Builder clearSide() {
        bitField0_ = (bitField0_ & ~0x00000020);
        side_ = getDefaultInstance().getSide();
        onChanged();
        return this;
      }
      /**
       * <code>optional string Side = 6;</code>
       */
      public Builder setSideBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000020;
        side_ = value;
        onChanged();
        return this;
      }

      // optional string Time = 7;
      private java.lang.Object time_ = "";
      /**
       * <code>optional string Time = 7;</code>
       */
      public boolean hasTime() {
        return ((bitField0_ & 0x00000040) == 0x00000040);
      }
      /**
       * <code>optional string Time = 7;</code>
       */
      public java.lang.String getTime() {
        java.lang.Object ref = time_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          time_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string Time = 7;</code>
       */
      public com.google.protobuf.ByteString
          getTimeBytes() {
        java.lang.Object ref = time_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          time_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string Time = 7;</code>
       */
      public Builder setTime(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000040;
        time_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string Time = 7;</code>
       */
      public Builder clearTime() {
        bitField0_ = (bitField0_ & ~0x00000040);
        time_ = getDefaultInstance().getTime();
        onChanged();
        return this;
      }
      /**
       * <code>optional string Time = 7;</code>
       */
      public Builder setTimeBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000040;
        time_ = value;
        onChanged();
        return this;
      }

      // optional bool IsActive = 8;
      private boolean isActive_ ;
      /**
       * <code>optional bool IsActive = 8;</code>
       */
      public boolean hasIsActive() {
        return ((bitField0_ & 0x00000080) == 0x00000080);
      }
      /**
       * <code>optional bool IsActive = 8;</code>
       */
      public boolean getIsActive() {
        return isActive_;
      }
      /**
       * <code>optional bool IsActive = 8;</code>
       */
      public Builder setIsActive(boolean value) {
        bitField0_ |= 0x00000080;
        isActive_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional bool IsActive = 8;</code>
       */
      public Builder clearIsActive() {
        bitField0_ = (bitField0_ & ~0x00000080);
        isActive_ = false;
        onChanged();
        return this;
      }

      // optional string MarketId = 9;
      private java.lang.Object marketId_ = "";
      /**
       * <code>optional string MarketId = 9;</code>
       */
      public boolean hasMarketId() {
        return ((bitField0_ & 0x00000100) == 0x00000100);
      }
      /**
       * <code>optional string MarketId = 9;</code>
       */
      public java.lang.String getMarketId() {
        java.lang.Object ref = marketId_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          marketId_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string MarketId = 9;</code>
       */
      public com.google.protobuf.ByteString
          getMarketIdBytes() {
        java.lang.Object ref = marketId_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          marketId_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string MarketId = 9;</code>
       */
      public Builder setMarketId(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000100;
        marketId_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string MarketId = 9;</code>
       */
      public Builder clearMarketId() {
        bitField0_ = (bitField0_ & ~0x00000100);
        marketId_ = getDefaultInstance().getMarketId();
        onChanged();
        return this;
      }
      /**
       * <code>optional string MarketId = 9;</code>
       */
      public Builder setMarketIdBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000100;
        marketId_ = value;
        onChanged();
        return this;
      }

      // optional string OrderId = 10;
      private java.lang.Object orderId_ = "";
      /**
       * <code>optional string OrderId = 10;</code>
       */
      public boolean hasOrderId() {
        return ((bitField0_ & 0x00000200) == 0x00000200);
      }
      /**
       * <code>optional string OrderId = 10;</code>
       */
      public java.lang.String getOrderId() {
        java.lang.Object ref = orderId_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          orderId_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string OrderId = 10;</code>
       */
      public com.google.protobuf.ByteString
          getOrderIdBytes() {
        java.lang.Object ref = orderId_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          orderId_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string OrderId = 10;</code>
       */
      public Builder setOrderId(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000200;
        orderId_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string OrderId = 10;</code>
       */
      public Builder clearOrderId() {
        bitField0_ = (bitField0_ & ~0x00000200);
        orderId_ = getDefaultInstance().getOrderId();
        onChanged();
        return this;
      }
      /**
       * <code>optional string OrderId = 10;</code>
       */
      public Builder setOrderIdBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000200;
        orderId_ = value;
        onChanged();
        return this;
      }

      // optional string tradingdate = 11;
      private java.lang.Object tradingdate_ = "";
      /**
       * <code>optional string tradingdate = 11;</code>
       */
      public boolean hasTradingdate() {
        return ((bitField0_ & 0x00000400) == 0x00000400);
      }
      /**
       * <code>optional string tradingdate = 11;</code>
       */
      public java.lang.String getTradingdate() {
        java.lang.Object ref = tradingdate_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          tradingdate_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string tradingdate = 11;</code>
       */
      public com.google.protobuf.ByteString
          getTradingdateBytes() {
        java.lang.Object ref = tradingdate_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          tradingdate_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string tradingdate = 11;</code>
       */
      public Builder setTradingdate(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000400;
        tradingdate_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string tradingdate = 11;</code>
       */
      public Builder clearTradingdate() {
        bitField0_ = (bitField0_ & ~0x00000400);
        tradingdate_ = getDefaultInstance().getTradingdate();
        onChanged();
        return this;
      }
      /**
       * <code>optional string tradingdate = 11;</code>
       */
      public Builder setTradingdateBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000400;
        tradingdate_ = value;
        onChanged();
        return this;
      }

      // optional int64 LastSeq = 12;
      private long lastSeq_ ;
      /**
       * <code>optional int64 LastSeq = 12;</code>
       */
      public boolean hasLastSeq() {
        return ((bitField0_ & 0x00000800) == 0x00000800);
      }
      /**
       * <code>optional int64 LastSeq = 12;</code>
       */
      public long getLastSeq() {
        return lastSeq_;
      }
      /**
       * <code>optional int64 LastSeq = 12;</code>
       */
      public Builder setLastSeq(long value) {
        bitField0_ |= 0x00000800;
        lastSeq_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional int64 LastSeq = 12;</code>
       */
      public Builder clearLastSeq() {
        bitField0_ = (bitField0_ & ~0x00000800);
        lastSeq_ = 0L;
        onChanged();
        return this;
      }

      // optional string PColor = 13;
      private java.lang.Object pColor_ = "";
      /**
       * <code>optional string PColor = 13;</code>
       */
      public boolean hasPColor() {
        return ((bitField0_ & 0x00001000) == 0x00001000);
      }
      /**
       * <code>optional string PColor = 13;</code>
       */
      public java.lang.String getPColor() {
        java.lang.Object ref = pColor_;
        if (!(ref instanceof java.lang.String)) {
          java.lang.String s = ((com.google.protobuf.ByteString) ref)
              .toStringUtf8();
          pColor_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string PColor = 13;</code>
       */
      public com.google.protobuf.ByteString
          getPColorBytes() {
        java.lang.Object ref = pColor_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b = 
              com.google.protobuf.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          pColor_ = b;
          return b;
        } else {
          return (com.google.protobuf.ByteString) ref;
        }
      }
      /**
       * <code>optional string PColor = 13;</code>
       */
      public Builder setPColor(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00001000;
        pColor_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string PColor = 13;</code>
       */
      public Builder clearPColor() {
        bitField0_ = (bitField0_ & ~0x00001000);
        pColor_ = getDefaultInstance().getPColor();
        onChanged();
        return this;
      }
      /**
       * <code>optional string PColor = 13;</code>
       */
      public Builder setPColorBytes(
          com.google.protobuf.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00001000;
        pColor_ = value;
        onChanged();
        return this;
      }

      // @@protoc_insertion_point(builder_scope:com.fss.fo.mserver.exchange.PutThroughInfo)
    }

    static {
      defaultInstance = new PutThroughInfo(true);
      defaultInstance.initFields();
    }

    // @@protoc_insertion_point(class_scope:com.fss.fo.mserver.exchange.PutThroughInfo)
  }

  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_com_fss_fo_mserver_exchange_PutThroughInfo_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_com_fss_fo_mserver_exchange_PutThroughInfo_fieldAccessorTable;

  public static com.google.protobuf.Descriptors.FileDescriptor
      getDescriptor() {
    return descriptor;
  }
  private static com.google.protobuf.Descriptors.FileDescriptor
      descriptor;
  static {
    java.lang.String[] descriptorData = {
      "\n\024PutThroughInfo.proto\022\033com.fss.fo.mserv" +
      "er.exchange\"\341\001\n\016PutThroughInfo\022\n\n\002Id\030\001 \001" +
      "(\t\022\016\n\006Symbol\030\002 \001(\t\022\013\n\003Vol\030\003 \001(\003\022\020\n\010Match" +
      "Vol\030\004 \001(\003\022\r\n\005Price\030\005 \001(\005\022\014\n\004Side\030\006 \001(\t\022\014" +
      "\n\004Time\030\007 \001(\t\022\020\n\010IsActive\030\010 \001(\010\022\020\n\010Market" +
      "Id\030\t \001(\t\022\017\n\007OrderId\030\n \001(\t\022\023\n\013tradingdate" +
      "\030\013 \001(\t\022\017\n\007LastSeq\030\014 \001(\003\022\016\n\006PColor\030\r \001(\tB" +
      "3\n\033com.fss.fo.mserver.exchangeB\024PutThrou" +
      "ghInfoProtos"
    };
    com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner assigner =
      new com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner() {
        public com.google.protobuf.ExtensionRegistry assignDescriptors(
            com.google.protobuf.Descriptors.FileDescriptor root) {
          descriptor = root;
          internal_static_com_fss_fo_mserver_exchange_PutThroughInfo_descriptor =
            getDescriptor().getMessageTypes().get(0);
          internal_static_com_fss_fo_mserver_exchange_PutThroughInfo_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_com_fss_fo_mserver_exchange_PutThroughInfo_descriptor,
              new java.lang.String[] { "Id", "Symbol", "Vol", "MatchVol", "Price", "Side", "Time", "IsActive", "MarketId", "OrderId", "Tradingdate", "LastSeq", "PColor", });
          return null;
        }
      };
    com.google.protobuf.Descriptors.FileDescriptor
      .internalBuildGeneratedFileFrom(descriptorData,
        new com.google.protobuf.Descriptors.FileDescriptor[] {
        }, assigner);
  }

  // @@protoc_insertion_point(outer_class_scope)
}
